买卖股票的最佳时机
01、题目分析
在leetcode上,股票相关的题目有8道之多:
而且这一类型的题,面试时出现的频率非常的高。稍微改一改条件,就让我们防不胜防。那我们如何攻克这一类题型呢?我们从最简单的一道开始看起:
第122题:买卖股票的最佳时机 II
给定一个数组,它的第 i 个元素是一支给定股票第 i 天的价格。
如果你最多只允许完成一笔交易(即买入和卖出一支股票),设计一个算法来计算你所能获取的最大利润。注意你不能在买入股票前卖出股票。
示例 1:
1. 输入: [7,1,5,3,6,4]2. 输出: 7
解释: 在第 2 天(股票价格 = 1)的时候买入,在第 3 天(股票价格 = 5)的时候卖出, 这笔交易所能获得利润 = 5-1 = 4 。 随后,在第 4 天(股票价格 = 3)的时候买入,在第 5 天(股票价格 = 6)的时候卖出, 这笔交易所能获得利润 = 6-3 = 3 。 示例 2:
1. 输入: [1,2,3,4,5]2. 输出: 4
解释: 在第 1 天(股票价格 = 1)的时候买入,在第 5 天 (股票价格 = 5)的时候卖出, 这笔交易所能获得利润 = 5-1 = 4 。 注意你不能在第 1 天和第 2 天接连购买股票,之后再将它们卖出。 因为这样属于同时参与了多笔交易,你必须在再次购买前出售掉之前的股票。 示例 3:
1. 输入: [7,6,4,3,1]2. 输出: 0
解释: 在这种情况下, 没有交易完成, 所以最大利润为 0。 题目分析:首先我们看一下题目中给出的两个条件: 1、不能参与多笔交易 。换句话讲,我们只能在手上没有股票的时候买入,也就是必须在再次购买前出售掉之前的股票 。像我们平时买股票时的追涨杀跌是不可以的。 2、尽可能地多进行交易 。这个非常好理解。像是黄金,一年基本上都有2-3次涨跌。我们只要把握住机会,在每一次涨跌的时候,低价卖入高价卖出,就可以使利益达到最大化。这个条件也是相当重要的,如果我们把这里变成,最多完成两笔交易,就变成另一道题。 现在题目搞清楚了,我们来思考一下。
02、题解分析
假设给定的数组为:[7, 1, 5, 3, 6, 4] 我们将其绘制成折线图,大概是下面这样:
如我们上面分析,我们要在满足1和2的条件下获取最大利益,其实就是尽可能多的低价买入高价卖出。而每一次上升波段,其实就是一次低价买入高价卖出 。而我们没有限制交易次数,也就是我们需要求出所有的上升波段的和 。上图里就是A+B,也就是(5-1)+(6-3) = 7,就是我们能获取到的最大利益。
其实也就是尽可能多的低价买入,高价卖出啦。
03、代码分析
根据以上分析,我们很容易得到下面的题解:
1. //GO2. func maxProfit(prices []int) int {3. if len(prices) < 2 {4. return 05. }6. dp := make([][2]int, len(prices))7. dp[0][0] = 08. dp[0][1] = -prices[0]9. for i := 1; i < len(prices); i++ {10. dp[i][0] = max(dp[i-1][0],dp[i-1][1]+prices[i])11. dp[i][1] = max(dp[i-1][0]-prices[i],dp[i-1][1])12. }13. return dp[len(prices)-1][0]14. }15. 16. func max(a,b int) int {17. if a > b {18. return a19. }20. return b21. }
04、题目扩展
图解的方式其实在各种算法题中,屡见不鲜。而我们通过图解的方式,也可以抽丝剥茧一样,一层一层剥掉算法题目的外壳,寻找到最直观的解题思路,直捣黄….咳咳,直奔核心。那我们又如何用图解的观察方式,来对本系列的其他题目寻找到一种通用解法,来规避题目中的陷阱呢?浩仔讲算法,我们下期再见喽!
整理人:豆包AI助手
